[POJ] 2965.The Pilots Brothers' refrigerator

2023-10-20 19:08

本文主要是介绍[POJ] 2965.The Pilots Brothers' refrigerator,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

The Pilots Brothers’ refrigerator

Time Limit: 1000MS      Memory Limit: 65536K
Total Submissions: 29786        Accepted: 11550     Special Judge

Description

The game “The Pilots Brothers: following the stripy elephant” has a quest where a player needs to 
open a refrigerator.
There are 16 handles on the refrigerator door. Every handle can be in one of two states: open or 
matrix 4х4. You can change the state of a handle in any location [i, j] (1 ≤ i, j ≤ 4). However, 
this also changes states of all handles in row i and all handles in column j.
The task is to determine the minimum number of handle switching necessary to open the refrigerator.

Input

The input contains four lines. Each of the four lines contains four characters describing the 
initial state of appropriate handles. A symbol “+” means that the handle is in closed state, whereas 
the symbol “−” means “open”. At least one of the handles is initially closed.

Output

The first line of the input contains N – the minimum number of switching. The rest N lines describe 
switching sequence. Each of the lines contains a row number and a column number of the matrix 
separated by one or more spaces. If there are several solutions, you may give any one of them.

Sample Input

-+--
----
----
-+--

Sample Output

6
1 1
1 3
1 4
4 1
4 3
4 4

题意:有4×4个把手的冰箱,规定转换把手的同时也要转换这一行和列的把手,问给定一个冰箱的把手状态,至少需要转换多少次,能使得冰箱的把手全为open(-)。
思路:一开始想着和POJ1753差不多,遂改了改1753的代码,结果超时了。。

#include <algorithm>
#include <bitset>
#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <string>
#include <vector>using namespace std;
int map = 0;
int state[16] = {4383, 8751, 17487, 34959, 4593, 8946, 17652, 35064,7953, 12066, 20292, 36744, 61713, 61986, 62532, 63624};
int step[16] = {0};//得到state数据
void init()
{for (int i = 1; i <= 16; i++){int v = 0, k = 1 << (i - 1);v |= k;int move = 1;for (int j = 4 - (i % 4); j > 0 && j != 4; j--){v |= k << move;++move;}move = 1;for (int j = (i % 4) ? (i % 4 - 1) : 3; j > 0; j--){v |= k >> move;++move;}move = 4;for (int j = (i % 4) ? (3 - i / 4) : (4 - i / 4); j > 0 && j != 4; j--){v |= k << move;move += 4;}move = 4;for (int j = i / 4; j > 0; j--){v |= k >> move;move += 4;}state[i - 1] = v;}
}
//打开第i个冰箱
void flip(int i)
{map ^= state[i];step[i] = !step[i];
}
//判断是否完成
bool check() { return (map == 0xFFFF); }
//寻找解 总共还要开n个门,当前开第i个门
bool find(int n, int i)
{if (n == 0)return check();for (; i < 16; i++){flip(i);if (find(n - 1, i))return true;flip(i); //遍历一种后翻转回来以便下次遍历}return false;
}int times()
{int time = 0;for (int i = 0; i < 16; i++)if (step[i])++time;return time;
}
int main()
{// init();for (int i = 0; i < 4; i++){for (int j = 0; j < 4; j++){map <<= 1;if (getchar() == '-')map |= 1;}getchar();}for (int i = 0; i < 16; i++){if (find(i, 0)){cout << times() << endl;for (int i = 3; i >= 0; i--)for (int j = 3; j >= 0; j--){if (step[i * 4 + j])cout << 4 - i << ' ' << 4 - j << endl;}system("pause");return 0;}}system("pause");return 0;
}

于是又百度了,看到个大神的思路:

先看一个简单的问题,如何把'+'变成'-'而不改变其他位置上的状态?
答案是将该位置(i,j)及位置所在的行(i)和列(j)上所有的handle更新一次,结果该位置被更新了7次,相应行(i)和列(j)的
handle被更新了6次,剩下的被更新了4次.被更新偶数次的handle不会造成最终状态的改变. 
因此得出高效解法,在每次输入碰到'+'的时候,自增该位置与相应的行和列,当输入结束后,遍历数组,所有为奇数的位置则是操作 
的位置,而奇数位置的个数之和则是最终的操作次数.
#include <algorithm>
#include <bitset>
#include <cstdio>
#include <cstring>
#include <fstream>
#include <iostream>
#include <string>
#include <vector>using namespace std;
int a[4][4] = {0};
int main()
{char c;for (int i = 0; i < 4; i++){for (int j = 0; j < 4; j++){cin >> c;if (c == '+'){for (int k = 0; k < 4; k++){//将同行列的都操作一次a[i][k] ^= 1;a[k][j] ^= 1;}a[i][j] ^= 1;}}}int sum = 0;for (int i = 0; i < 4; i++)for (int j = 0; j < 4; j++)if (a[i][j])sum++;printf("%d\n", sum);for (int i = 0; i < 4; i++){for (int j = 0; j < 4; j++){if (a[i][j])printf("%d %d\n", i + 1, j + 1);}}return 0;
}

这篇关于[POJ] 2965.The Pilots Brothers' refrigerator的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/249128

相关文章

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1258 Agri-Net(最小生成树模板代码)

感觉用这题来当模板更适合。 题意就是给你邻接矩阵求最小生成树啦。~ prim代码:效率很高。172k...0ms。 #include<stdio.h>#include<algorithm>using namespace std;const int MaxN = 101;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int n

poj 1287 Networking(prim or kruscal最小生成树)

题意给你点与点间距离,求最小生成树。 注意点是,两点之间可能有不同的路,输入的时候选择最小的,和之前有道最短路WA的题目类似。 prim代码: #include<stdio.h>const int MaxN = 51;const int INF = 0x3f3f3f3f;int g[MaxN][MaxN];int P;int prim(){bool vis[MaxN];

poj 2349 Arctic Network uva 10369(prim or kruscal最小生成树)

题目很麻烦,因为不熟悉最小生成树的算法调试了好久。 感觉网上的题目解释都没说得很清楚,不适合新手。自己写一个。 题意:给你点的坐标,然后两点间可以有两种方式来通信:第一种是卫星通信,第二种是无线电通信。 卫星通信:任何两个有卫星频道的点间都可以直接建立连接,与点间的距离无关; 无线电通信:两个点之间的距离不能超过D,无线电收发器的功率越大,D越大,越昂贵。 计算无线电收发器D

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

uva 10061 How many zero's and how many digits ?(不同进制阶乘末尾几个0)+poj 1401

题意是求在base进制下的 n!的结果有几位数,末尾有几个0。 想起刚开始的时候做的一道10进制下的n阶乘末尾有几个零,以及之前有做过的一道n阶乘的位数。 当时都是在10进制下的。 10进制下的做法是: 1. n阶位数:直接 lg(n!)就是得数的位数。 2. n阶末尾0的个数:由于2 * 5 将会在得数中以0的形式存在,所以计算2或者计算5,由于因子中出现5必然出现2,所以直接一

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i